1. Bill Payments
ZamuPay API Documentation
  • Introduction
  • Definitions
    • Data Types
    • Transactions Response Codes
    • MCCMNC Codes
  • Authorization
    • Overview
    • Token Request
      POST
    • Find Transaction Routes
      GET
    • Health Check
      GET
  • Payouts
    • Overview
    • Payment Order Request Information
    • Mobile Money Requests
      • Overview
      • Mobile Transfers- Safaricom (M-Pesa)
      • Mobile Transfers - Airtel Money
    • Payment Order Requests - Business Transfers
      POST
    • Payment Order Requests - Bank Transfers
      POST
    • Find Payment Order By OriginatorConversationId
      GET
    • Reject Order By OriginatorConversationId
      POST
  • Pay-Ins
    • Payment Links
      • Overview
      • Create Payment Link
      • Find Payment Links By Id
      • Update Payment Link
    • Express Deposits
      • Overview
      • Express Deposit Request
      • Find Express Deposit By OriginatorConversationId
    • C2B IPN (Callback)
      • C2B IPN Overview
  • Card Payments
    • ZamuPay Server To Server Card Integration
      • Overview
      • 1. Authentication
        • Generate Auth Token
      • 2. Capture Context
        • Generate Capture Context
      • 3. Core Payment Flow
        • Payment Authorisation
        • Payment Capture
        • Payment Void
        • Payment Refund
      • 4. 3D Secure (Payer Authentication)
        • 3DS Setup
        • 3DS Enrolment Check
        • 3DS Validate Result
      • 5. Decision Manager (Fraud Screening)
        • Fraud Screen Transaction
      • 6. Payment Instruments (Card Tokenisation)
        • Save Card
        • Retrieve Saved Card
        • Delete Saved Card
      • 7. Transaction Search
        • Query Transactions
        • Get Transaction by ID
      • 8. Webhooks
        • Register Webhook Endpoint
        • List Registered Webhooks
        • Delete Webhook Endpoint
    • Cards Processing
      • Overview
      • Checkout Order Request
      • Query Checkout Request
      • Checkout Callback Request
  • Account Validation
    • Overview
    • Account Number Validation Request
    • Find KYC Status by SystemTraceAuditNumber
    • Account Validation
    • Find Account Validation Status by SystemTraceAuditNumber
  • Platform Services
    • Airtime Purchase
      • Overview
      • Airtime Purchase
      • Find Airtime Purchases By OriginatorConversationId
    • Customer Accounts
      • Balance Check
      • Find Charges By TransactionTypeId
    • Bill Payments
      • Overview
      • Bill Request Validation
        POST
      • Bill Request Payment
        POST
      • Find Bill Services
        GET
      • Find Bill Number By Service Id and Account Number
        GET
      • Find Bill Request By Originator Converstion Id
        GET
      • Bill Number
        POST
  1. Bill Payments

Bill Request Validation

https://auth.zamupay.com
https://auth.zamupay.com
https://auth.zamupay.com
https://auth.zamupay.com
POST
/v1/bill-payments
This is a POST request that is responsible for initiating a Bill Request Validation.
Note: The transactionType for this endpoint is 3
Note: A valid token is required for authentication as it expires after every hour. Refer to Token Request to generate a new token.

Request

Authorization
Body Params application/jsonRequired

Examples

Responses

🟢200Success
application/json
Bodyapplication/json

Request Request Example
Shell
JavaScript
Java
Swift
curl --location 'https://auth.zamupay.com/v1/bill-payments' \
--header 'Content-Type: application/json' \
--data '{
    "routeId": "068d89af-be67-f011-bb46-0e7d952d79b7",
    "ServiceId": "bc97d2b1-4828-f111-bc5a-0e7d952d79b7",
    "accountNumber": "1111111",
    "transactionType": 3,
    "transactionDesc": "Bill Payment NEW",
    "originatorConversationId": "{{$guid}}",
    "msisdn": "254710000000",
    "narration": "Testing",
    "amount": 15,
    "customerNames": "IRINA MUTHONI",
    "countryCode": "KE",
    "currencyCode": "KES",
    "saveBillerNumber": true,
    "callBackUrl": "https://bright-sparrow-356.webhook.cool"
}'
Response Response Example
{
    "message": {
        "appDomainName": "TEST",
        "remarks": "Bill Payment submission accepted",
        "originatorConversationId": "f3b3c682-bf08-4c4c-a65a-4ad998019d9e",
        "systemConversationId": "01000000-0129-0a00-1ac0-08de9ac69d58",
        "timestamp": "2026-04-15T08:11:37.3471201Z",
        "dueDate": null,
        "dueAmount": 0.0,
        "currency": "KES",
        "accountCustomerName": "",
        "active": "Unknown",
        "responseCode": null,
        "responseDesc": null
    }
}
Modified at 2026-04-16 18:17:00
Previous
Overview
Next
Bill Request Payment
Built with